/* (c) Copyright 1985 Cary Buchman and Daniel M. Berry */
/* (c) Copyright 1987 Berry Computer Scientists, Ltd. */

/******************************************************* 
******************************************************** 
**                                                    **
** this file includes the main ffortid driver routine **
**                                                    **
******************************************************** 
********************************************************/ 

#include <stdio.h>
#include "TOKEN.h"
#include "TABLE.h"
#include "lex.h"
#include "lexer"
#include "macros.h"

/************************************************************************/
/************************************************************************/

#define  MARK_PREVIOUS_END   in_end->ending = END

#define  ADD_CHAR1(TOKTYP,BEGN,CHAR1) tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,NULL,NULL,in_font_name,width1(CHAR1,in_size,in_font)); add_token(tokenptr, &in_start, &in_end )

#define  ADD_CHAR2(TOKTYP,BEGN,CHAR1,CHAR2) tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,NULL,in_font_name,width2(yytext+1,in_size,in_font)); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
#define  ADD_CHARN(TOKTYP,BEGN,CHAR1,CHAR2,CHAR3) tokenptr = new_token(TOKTYP,in_size,in_font,in_horizontal,in_vertical,in_lr,BEGN,NOT_END,CHAR1,CHAR2,CHAR3,in_font_name,widthn(yytext+1)); add_token(tokenptr, &in_start, &in_end )

/******************************************************************************/
/* I think this is better ... Johny                                           */
#define  USAGE  "Usage: %s [-wpaperwidth] [-rfont_position_list] [-afont_position_list] [-s[nfla]]\n"
/******************************************************************************/

  int   in_font=1;                     /* current input font                  */
  int   in_size=0;                     /* current input size                  */
  int   in_horizontal=0;               /* current input horizontal position   */
  int   in_vertical=0;                 /* current input vertical position     */
  char  in_font_name[3];               /* current input font name             */
  bool  in_lr=LEFT_TO_RIGHT;           /* current input font direction        */
  TABLENTRY in_fontable[256];          /* current input font table            */

  int   out_font=1;                    /* current output font                 */
  int   out_size=0;                    /* current output size                 */
  int   out_horizontal=0;              /* current output horizontal position  */
  int   out_vertical=0;                /* current output vertical position    */
  char  out_font_name[3];              /* current output font name            */
  TABLENTRY out_fontable[256];         /* current output font table           */

  bool  direction_table[256];          /* formatting direction of font i      */
  bool	arabic_fonts[256];             /* whether font i is arabic or not     */
  char  stretch_stage='a';             /* the stretching stage. default is NOT
                                       to stretch.                            */
  char  *device;                       /* output device                       */
  char  c;                             /* for flushing included postscript
                                       and psfig text    */
  static char copyright[]="(c) Copyright 1987 Berry Computer Scientists, Ltd.";

/******************************************************************************/
/******************************************************************************/

main (argc,argv)
  int          argc;
  char         *argv[];

{

  extern char  yytext[];    /* lex token string                               */

                            /* indicates the predominate formatting direction */
  bool         lr_predom = LEFT_TO_RIGHT;
  TOKENPTR     in_start  = NULL;       /* ptr to start of internal input line */
  TOKENPTR     in_end    = NULL;       /* ptr to end of internal input line   */

  double       paper_inch=8.5;         /* paper width in inches         */
  int          paper_width;            /* paper width in points         */
  int          token_num;              /* current lex token                   */
  bool         new_word=TRUE;          /* indicates word token was encountered*/
  bool         previous_D=FALSE;       /* indicates a D_token was just done   */
  char         small_motion[3];        /* motion from hc_token                */
  char         f_name[3];              /* new font name                       */
  int          f_num;                  /* new font number                     */
  TOKENPTR     tokenptr;               /* ptr to new internal tokens          */
  TOKENPTR     new_token();            /* ptr to new internal tokens          */
  char         *calloc();
  double       atof();
  int          i,j,k;                  /* counter index  */
  char         *tmpyy;                 /* temp ptr for yytext */

/************************************************************************/
/************************************************************************/

  for (i=0;i<=255;i++) {		/* johny */
    SET_DIRECTION(i,LEFT_TO_RIGHT);
	RESET_AR_FONT(i);
  }

  if (--argc > 0)
  {
    if (argv[1][0] == '-')
    {
      i=1;
      while(i<= argc)
      {
        switch (argv[i][1])

        {
		  /* specify the fonts to be reversed */
          case 'r':
          case 'R':
            {
              if (strlen(argv[i]) > 2)
                SET_DIRECTION(atoi(argv[i++]+2),RIGHT_TO_LEFT);
              else
                i++;
              while( (i<=argc) && (argv[i][0] != '-') )
                SET_DIRECTION(atoi(argv[i++]),RIGHT_TO_LEFT);
              break;
            }
		  /* specify the Arabic Fonts. Only Arabic Fonts are stretched */
          case 'a':
          case 'A':
            {
              if (strlen(argv[i]) > 2)
                SET_AR_FONT(atoi(argv[i++]+2));
              else
                i++;
              while( (i<=argc) && (argv[i][0] != '-') )
                SET_AR_FONT(atoi(argv[i++]));
              break;
            }
		  /* specify paper width */
          case 'w':
          case 'W':
            {
              if (strlen(argv[i]) > 2)
                paper_inch = atof(argv[i++]+2);
              else
              {
                i++;
                paper_inch = atof(argv[i++]);
              }
              break;
            }
		  /* specify the stretching style.
			 n: dont stretch (default0
			 f: stretch final Arabic word.
			 l: stretch last Arabic word(s).
			 a: stretch all the Arabic words in the line, equally */
          case 's':
          case 'S':
			{
			  stretch_stage = *(argv[i++]+2);
			  if (stretch_stage == '\0') 
			    stretch_stage = 'a';
			  if ( (stretch_stage != 'n') && (stretch_stage != 'f') &&
				   (stretch_stage != 'l') && (stretch_stage != 'a') )
			  {
				fprintf(stderr,"%s: incorrect stretch_stage\n",argv[0]);
				exit(1);
		      }	
              break;
			}
          default:
            {
              fprintf(stderr,"FFORTID: illegal argument: %s\n",argv[i]);
              exit(1);
              break;
            }
        }
      }
    }
    else
    {
      printf(USAGE,argv[0]);
      exit(1);
    }
  }
              
/************************************************************************/
/************************************************************************/

  while ( (token_num=yylex()) ) /* get each token until the end-of-file */
  {


    switch (token_num)                 /* process based on token type */
    {

      case s_token:
           {
             in_size = atoi(yytext+1);
             break;
           }

      case f_token:
           {
             in_font = atoi(yytext+1);
             in_lr   = in_fontable[in_font].direction;
             strcpy(in_font_name,in_fontable[in_font].name);
             break;
           }
      case c_token:
           {
             if (new_word)
             {
               ADD_CHAR1(c_token,BEGINING,*(yytext+1));
               new_word =FALSE;
             }
             else
             {
               ADD_CHAR1(c_token,NOT_BEGIN,*(yytext+1));
             }
             break;
           }
      case C_token:
           {
             if (new_word)
             {
               ADD_CHAR2(C_token,BEGINING,*(yytext+1),*(yytext+2));
               new_word = FALSE;
             }
             else
             {
               ADD_CHAR2(C_token,NOT_BEGIN,*(yytext+1),*(yytext+2));
             }
             break;
           }
      case N_token:
           {
             if (new_word)
             {
               ADD_CHARN(N_token,BEGINING,*(yytext+1),*(yytext+2),*(yytext+3));
               new_word = FALSE;
             }
             else
             {
               ADD_CHARN(N_token,NOT_BEGIN,*(yytext+1),*(yytext+2),*(yytext+3));
             }
             break;
           }
      case H_token:
           {
             in_horizontal = atoi(yytext+1);
             break;
           }
      case V_token:
           {
             in_vertical = atoi(yytext+1);
             break;
           }
      case h_token:
           {
             in_horizontal = in_horizontal + atoi(yytext+1);
             break;
           }
      case v_token:
           {
             in_vertical = in_vertical + atoi(yytext+1);
             break;
           }
      case hc_token:
           {
             small_motion[0] = *(yytext);
             small_motion[1] = *(yytext+1);
             small_motion[2] = '\0';
             in_horizontal = in_horizontal + atoi(small_motion);
             if (new_word)
             {
               ADD_CHAR1(c_token,BEGINING,*(yytext+2));
               new_word = FALSE;
             }
             else
             {
               ADD_CHAR1(c_token,NOT_BEGIN,*(yytext+2));
             }
             break;
           }
      case n_token:
           {
             if (!previous_D)
             {
               if(in_end != NULL)
               {
                 MARK_PREVIOUS_END;
                 if (lr_predom)
                   dump_line(&in_start,&in_end,RIGHT_TO_LEFT);
                 else
                 {
                   reverse_line(&in_start,&in_end,paper_width);
                   dump_line(&in_start,&in_end,LEFT_TO_RIGHT);
                 }
               }
             }
             else
               previous_D = FALSE;
             DUMP_LEX(yytext);
             break;
           }
      case w_token:
           {
             if(in_end != NULL)
               MARK_PREVIOUS_END;
             new_word = TRUE;
             break;
           }
      case p_token:
           {
             put_page_token(yytext);
             break;
           }
      case trail_token:
      case pause_token:
      case height_token:
      case slant_token:
      case include_token:
      case control_token:
           {
             DUMP_LEX(yytext);
             break;
           }
      case res_token:
           {
             DUMP_LEX(yytext);
             for(tmpyy=yytext;(*tmpyy<'0')||(*tmpyy>'9');tmpyy++);
             paper_width = paper_inch * atoi(tmpyy);
             break;
           }
      case init_token:
           {
             DUMP_LEX(yytext);
             width_init();
             break;
           }
      case stop_token:
           {
             printf("V%d\n",in_vertical);
             DUMP_LEX(yytext);
             break;
           }
      case newline_token:
           {
             break;
           }
      case dev_token:
           {
             device = calloc(1,strlen(yytext)-3);
             strcpy(device,yytext+4);
             DUMP_LEX(yytext);
             break;
           }
      case font_token:
           {
             font_info(yytext,&f_num,f_name);
             new_font(f_num,f_name,FONT_DIRECTION(f_num),in_fontable);
             loadfont(f_num,f_name,NULL);
             strcpy (out_fontable[f_num].name,in_fontable[f_num].name);
             out_fontable[f_num].direction = in_fontable[f_num].direction;
             DUMP_LEX(yytext);
             break;
           }
      case PR_token:
           {
             lr_predom = RIGHT_TO_LEFT;
             break;
           }
      case PL_token:
           {
             lr_predom = LEFT_TO_RIGHT;
             break;
           }
      case postscript_begin_token:
           {
             DUMP_LEX(yytext);
                /* copy everything up to and including 2 lines */
                /* containing PE\ and .\ */
                while ( ( c = getchar() ) != EOF ) {
			putchar(c);
			if ( c == 'P' ) {
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'E') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\\') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '.') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\\') goto not_end_PS_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_PS_yet;
				}
				goto done_flushing_PS;
			}
		not_end_PS_yet:;
                }
             goto done;
	     done_flushing_PS:
             break;
           }
      case psfig_begin_token:
           {
             printf("H%d\n",in_horizontal);
             printf("V%d\n",in_vertical);
             DUMP_LEX(yytext);
                /* copy everything up to and including line */
                /* containing "x X pendFig"*/
                while ( ( c = getchar() ) != EOF ) {
			putchar(c);
			if ( c == 'x' ) {
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != ' ') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'X') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != ' ') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'p') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'e') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'n') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'd') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'F') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'i') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != 'g') goto not_end_psfig_yet;
				}
				if ( ( c = getchar() ) != EOF ) {
					putchar(c);
					if (c != '\n') goto not_end_psfig_yet;
				}
				goto done_flushing_psfig;
			}
		not_end_psfig_yet:;
                }
             goto done;
	     done_flushing_psfig:
             break;
           }
      case D_token:
           {
             printf("H%d\n",in_horizontal);
             printf("V%d\n",in_vertical);
             printf("%s\n",yytext);
             tmpyy = yytext+1;
             if (*tmpyy == 'l' || *tmpyy == '-')
             {
               k = 0;
               while( ((*tmpyy < '0') || (*tmpyy > '9')) && (*tmpyy != '-') )
                 tmpyy++;
               while (*tmpyy != '\0')
               {
                 if(k=1-k)
                   in_horizontal += atoi(tmpyy);
                 else
                   in_vertical   += atoi(tmpyy);
                 while(((*tmpyy >= '0') && (*tmpyy <= '9')) || (*tmpyy == '-') )
                   tmpyy++; 
                 while( ((*tmpyy < '0') || (*tmpyy > '9')) && (*tmpyy != '-')
                        && (*tmpyy != '\0') )
                   tmpyy++;
               }
             }
             out_horizontal = in_horizontal;
             out_vertical = in_vertical;
             previous_D = TRUE;
           }
    } /* end switch */
  }  /* end while */
  done:;
} /* end main() */
